set classlib to DynaForm alias DynaForm Additive

do form DynaForm

return

procedure AcceptKey
lparameters p1int, p2bits, p3okString, p4exstring

local OptionBits
OptionBits = IIF(empty( m.p2bits ), 0, m.p2bits)

DO CASE
** Exclude string absolute override
case (VARTYPE( m.p4exString ) == "C") and ;
  (CHR( m.p1int ) $ m.p4exString)
    return .f.

** Include string absolute override
case (VARTYPE( m.p3okString ) == "C") and ;
  (CHR( m.p1int ) $ m.p3okString)
    return

** Allow all printable characters
case empty( m.OptionBits )
    return BETWEEN(m.p1int, 32, 126)

** Allow control characters to pass through
case not BETWEEN(m.p1int, 32, 126)
    return && special characters

case BITAND(m.OptionBits, 2) = 2
    DO CASE
** Allow numerals only
    case BETWEEN(m.p1int, 48, 57)
        return

** Block all others except control characters
    case BETWEEN(m.p1int, 32, 126)
        return .f.

    ENDCASE

case BITAND(m.OptionBits, 4) = 4
** Block special characters except underscore
    if (m.p1int = 34) or (CHR( m.p1int ) $ ;
       " !$%&'()*+,:;<=>?@[\]^`{|}-.#~/")
        return .f. && Double quote special treatment
    endif && Double quote special treatment

case BITAND(m.OptionBits, 8) = 8
** Allow _-.#~/
    if (m.p1int = 34) or (CHR( m.p1int ) $ ;
       " !$%&'()*+,:;<=>?@[\]^`{|}")
        return .f.
    endif

** Allow just 26 characters plus numerals
case BITAND(m.OptionBits, 16) = 16
    DO CASE
    case BETWEEN(m.p1int, 48, 57)
        return

    case BETWEEN(m.p1int, 65, 90)
        return

    case BETWEEN(m.p1int, 97, 122)
        if BITAND(m.OptionBits, 1) = 1
            keybo CHR(m.p1int - 32) clear
            return .f.
        endif
        return

    case BETWEEN(m.p1int, 32, 126)
        return .f.

    ENDCASE
    return

ENDCASE

** Finally, upper case if necessary
if (BITAND(m.OptionBits, 1) = 1) and ;
    BETWEEN(m.p1int, 97, 122)
    keybo CHR(m.p1int - 32) clear
    return .f.
endif
return

